'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PreloadLink = exports.configure = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _Object$freeze;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _helpers = require('./helpers');

var _constants = require('./constants');

var c = _interopRequireWildcard(_constants);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var globalLinkState = Object.freeze((_Object$freeze = {}, _defineProperty(_Object$freeze, c.ON_LOADING, _helpers.noop), _defineProperty(_Object$freeze, c.ON_SUCCESS, _helpers.noop), _defineProperty(_Object$freeze, c.ON_FAIL, _helpers.noop), _defineProperty(_Object$freeze, c.ON_NAVIGATE, _helpers.noop), _defineProperty(_Object$freeze, 'process', {
    uid: 0,
    busy: false,
    cancelUid: null,
    canCancel: true
}), _Object$freeze));

var setGlobalLinkState = function setGlobalLinkState(nextState) {
    globalLinkState = Object.freeze(_extends({}, globalLinkState, nextState));
};

var configure = exports.configure = function configure(options) {
    var _setGlobalLinkState;

    setGlobalLinkState((_setGlobalLinkState = {}, _defineProperty(_setGlobalLinkState, c.ON_LOADING, options[c.ON_LOADING] || _helpers.noop), _defineProperty(_setGlobalLinkState, c.ON_SUCCESS, options[c.ON_SUCCESS] || _helpers.noop), _defineProperty(_setGlobalLinkState, c.ON_FAIL, options[c.ON_FAIL] || _helpers.noop), _defineProperty(_setGlobalLinkState, c.ON_NAVIGATE, options[c.ON_NAVIGATE] || _helpers.noop), _setGlobalLinkState));
};

var PreloadLink = exports.PreloadLink = function (_React$Component) {
    _inherits(PreloadLink, _React$Component);

    // Initialize the lifecycle hooks
    function PreloadLink() {
        _classCallCheck(this, PreloadLink);

        var _this = _possibleConstructorReturn(this, (PreloadLink.__proto__ || Object.getPrototypeOf(PreloadLink)).call(this));

        _this.setLoading = function () {
            var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _helpers.noop;
            var _globalLinkState = globalLinkState,
                process = _globalLinkState.process;
            var noInterrupt = _this.props.noInterrupt;

            var nextProcess = {
                uid: _this.uid,
                busy: true
            };

            if (!noInterrupt && process.busy && process.uid !== _this.uid) {
                nextProcess.cancelUid = process.uid;
            } else if (noInterrupt) {
                // any further clicks can not cancel this process
                nextProcess.canCancel = false;
            }

            setGlobalLinkState({
                process: _extends({}, globalLinkState.process, nextProcess)
            });

            _this.setState({ loading: true }, callback);
        };

        _this.setLoaded = function () {
            var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _helpers.noop;

            var nextProcess = {
                uid: 0,
                cancelUid: null,
                busy: false
            };

            if (!globalLinkState.process.canCancel) {
                // reset for further navigation
                nextProcess.canCancel = true;
            }

            setGlobalLinkState({
                process: _extends({}, globalLinkState.process, nextProcess)
            });

            _this.setState({ loading: false }, callback);
        };

        _this.navigate = function () {
            var _this$props = _this.props,
                history = _this$props.history,
                to = _this$props.to;

            var hook = function hook() {
                return _this.executeHook(c.ON_NAVIGATE);
            };

            history.push(to);

            if (_this.props[c.ON_NAVIGATE]) {
                _this.props[c.ON_NAVIGATE](hook);
            } else {
                hook();
            }
        };

        _this.executeHook = function (state) {
            var fn = globalLinkState[state];

            if (!fn) return;

            if (typeof fn !== 'function') {
                console.error('PreloadLink: Method for lifecycle \'' + state + '\' is not a function.');
            } else {
                fn();
            }
        };

        _this.prepareHookCall = function (state) {
            var fn = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _helpers.noop;

            var setLoadState = state === c.ON_LOADING ? _this.setLoading : _this.setLoaded;
            var hook = function hook() {
                return _this.executeHook(state);
            };

            if (_this.props[state]) {
                if (typeof _this.props[state] !== 'function') {
                    console.error('PreloadLink: Method for lifecycle \'' + state + '\' is not a function.');
                } else {
                    _this.props[state](hook);
                    setLoadState(fn);
                }
            } else {
                setLoadState(function () {
                    hook();
                    fn();
                });
            }
        };

        _this.unwrapWithMiddleware = function (fn) {
            return fn().then(function (data) {
                _this.props.loadMiddleware(data);
            });
        };

        _this.prepareNavigation = function () {
            var _globalLinkState2 = globalLinkState,
                process = _globalLinkState2.process;
            var load = _this.props.load;

            var isArray = Array.isArray(load);
            var toLoad = void 0;

            // create functions of our load props
            if (isArray) {
                var loadList = load.map(function (fn) {
                    return _this.unwrapWithMiddleware(fn);
                });
                toLoad = Promise.all(loadList);
            } else {
                toLoad = _this.unwrapWithMiddleware(load);
            }

            // wait for all async functions to resolve
            // set in- and external loading states and proceed to navigation if successful
            // TODO: give error if function does not return a promise with explanation
            toLoad.then(function () {
                // do not perform further navigation if this was ordered for cancel
                if (process.cancelUid === _this.uid) {
                    return false;
                }

                _this.prepareHookCall(c.ON_SUCCESS, _this.navigate);
            }).catch(function () {
                // loading failed. Set in- and external states to reflect this
                _this.prepareHookCall(c.ON_FAIL);
            });
        };

        _this.handleClick = function (e) {
            var _globalLinkState3 = globalLinkState,
                process = _globalLinkState3.process;
            var onClick = _this.props.onClick;

            // prevents navigation

            if (e && e.preventDefault) {
                e.preventDefault();
            }

            // prevent navigation if we can't override a load with a new click
            if (process.busy && !process.canCancel) return;

            onClick();

            if (!_this.props.load) {
                // nothing to load -- we can navigate
                _this.navigate();
            } else {
                // fire external loading method
                _this.prepareHookCall(c.ON_LOADING);

                if (!_this.state.loading) {
                    _this.prepareNavigation();
                }
            }
        };

        _this.state = {
            loading: false
        };

        _this.uid = (0, _helpers.uuid)();
        return _this;
    }

    // navigate with react-router to new URL


    // NOTE: it's best to use prepareHookCall if you want to execute hooks,
    // because it will ensure the correct loading state is set


    // prepares the page transition. Wait on all promises to resolve before changing route.


    _createClass(PreloadLink, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                to = _props.to,
                children = _props.children,
                navLink = _props.navLink,
                className = _props.className,
                activeClassName = _props.activeClassName;

            var Element = navLink || activeClassName ? _reactRouterDom.NavLink : _reactRouterDom.Link;
            var props = {};

            if (navLink) {
                props.activeClassName = activeClassName;
            }

            return _react2.default.createElement(
                Element,
                _extends({ className: className, to: to, onClick: this.handleClick }, props),
                children
            );
        }
    }]);

    return PreloadLink;
}(_react2.default.Component);

PreloadLink.getGlobalState = function () {
    return globalLinkState;
};

PreloadLink.propTypes = {
    children: _propTypes2.default.any,
    history: _propTypes2.default.shape({
        push: _propTypes2.default.func
    }),
    load: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.arrayOf(_propTypes2.default.func)]),
    to: _propTypes2.default.string.isRequired,
    onLoading: _propTypes2.default.func,
    onSuccess: _propTypes2.default.func,
    onFail: _propTypes2.default.func,
    onNavigate: _propTypes2.default.func,
    noInterrupt: _propTypes2.default.bool,
    loadMiddleware: _propTypes2.default.func,
    className: _propTypes2.default.string,
    navLink: _propTypes2.default.bool,
    activeClassName: _propTypes2.default.string,
    onClick: _propTypes2.default.func
};

PreloadLink.defaultProps = {
    onLoading: null,
    onSuccess: null,
    onFail: null,
    onNavigate: null,
    noInterrupt: false,
    loadMiddleware: _helpers.noop,
    navLink: false,
    onClick: _helpers.noop
};

// component
exports.default = (0, _reactRouterDom.withRouter)(PreloadLink);